using System;
using System.Diagnostics;
using System.Runtime.InteropServices;
using System.Text;
using Microsoft.InterOp.SmtpEvents;

namespace DsnRewriter
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	[Guid("68AFA1D7-CF56-4509-BCD4-74217A76AAA8")]
	public class DsnRewriter: IDSNGenerationSink
	{
		#region IDSNGenerationSink Members

		public void OnSyncPostGenerateDSN(ISMTPServer pISMTPServer, IMailMsgProperties pIMsgOrig, uint dwDSNAction, uint cRecipsDSNd, IMailMsgProperties pIMsgDSN, IMailMsgPropertyBag pIDSNProperties)
		{
			// TODO:  Add DsnRewriter.OnSyncPostGenerateDSN implementation
		}

		public void OnSyncGetDSNRecipientIterator(ISMTPServer pISMTPServer, IMailMsgProperties pIMsg, IMailMsgPropertyBag pIDSNProperties, uint dwStartDomain, uint dwDSNActions, IDSNRecipientIterator pIRecipIterIN, out IDSNRecipientIterator ppIRecipIterOUT)
		{
			// TODO:  Add DsnRewriter.OnSyncGetDSNRecipientIterator implementation
			ppIRecipIterOUT = null;
		}

public void OnSyncGenerateDSN(ISMTPServer pISMTPServer, IDSNSubmission pIDSNSubmission, IMailMsgProperties pIMsg, IMailMsgPropertyBag pIDSNProperties, IDSNRecipientIterator pIRecipIter)
{
	StringBuilder sb;
	IMailMsgRecipientsBase recipients;
	string domain;

	Trace.WriteLine("[DSNRewriter] OnSyncGenerateDSN called");
	try
	{
		recipients = (IMailMsgRecipientsBase) pIMsg;
		
		sb = new StringBuilder(512);
		try 
		{
			recipients.Item(0, (uint) _CAT_ADDRESS_TYPE.CAT_SMTP, 512, sb);
			domain = sb.ToString();
			domain = domain.Substring(domain.IndexOf("@")+1);

			Trace.WriteLine("[DSNRewriter] Domain of first recipient is: " + domain);

			Trace.WriteLine("[DSNRewriter] Setting default domain to " + domain);
			pIDSNProperties.PutStringA((uint) eDSNProperties.DSNPROP_SZ_DEFAULTDOMAIN, domain);	
			Trace.WriteLine("[DSNRewriter] Done");
		}
		catch (Exception ex)
		{
			Trace.WriteLine("[DSNRewriter] The following exceptions occured: " + ex.ToString());
		}

	}
	catch (Exception ex)
	{
		Trace.WriteLine("[DSNRewriter] Failed. Exception: " + ex.ToString());
	}
}

		public void OnSyncSinkInit(uint dwVSID)
		{
			Trace.WriteLine("OnSyncSinkInit");
		}

		#endregion
	}
}
